(*
**
** PORTS.INC, Parallel/Serial/Soundblaster ports for SYSINFO
**
** Copyright (c) 1996 by Maarten Bekers
**
** Created : 03-May-1996
** Last update : 03-May-1996
**
**
*)

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Procedure ShowParallelPorts;
Var Teller : Byte;
    Aantal : Byte;
Begin;
 Aantal := 00;
 If MemW[BiosDSeg: $08] <> $0000 then
  Aantal := 01;
 If MemW[BiosDSeg: $0A] <> $0000 then
  Aantal := 02;
 If MemW[BiosDSeg: $0C] <> $0000 then
  Aantal := 03;
 If MemW[BiosDSeg: $0E] <> $0000 then
  Aantal := 04;

 If Aantal>00 then
  Begin;
   Writeln('ParallelPorts: ', Aantal);
   Writeln;
   Writeln('Device       :');
   Writeln('Base port    :');
   Writeln('Busy         :');
   Writeln('Acknowledge  :');
   Writeln('Out of paper :');
   Writeln('Selected     :');
   Writeln('I/O Error    :');
   Writeln('Time Out     :');

   For Teller:=01 to Aantal
    do Begin;
         Regs.AH := $02;
         Regs.DX := Teller - 01;
         Intr($17, Regs);
         GotoXY(08 + (6 * Teller), 03); Writeln('LPT', Teller);
         GotoXY(08 + (6 * Teller), 04); Writeln('$', HexWord(MemW[BIOSDSeg: 2 * 
Teller + 6]));
         GotoXY(08 + (6 * Teller), 05); Writeln(Bool2Str(NOT ReadBit(Regs.AH,
07)));
         GotoXY(08 + (6 * Teller), 06); Writeln(Bit2Str(Regs.AH, 06));
         GotoXY(08 + (6 * Teller), 07); Writeln(Bit2Str(Regs.AH, 05));
         GotoXY(08 + (6 * Teller), 08); Writeln(Bit2Str(Regs.AH, 04));
         GotoXY(08 + (6 * Teller), 09); Writeln(Bit2Str(Regs.AH, 03));
         GotoXY(08 + (6 * Teller), 10); Writeln(Bit2Str(Regs.AH, 00));
       End; { For Teller }

  End { If Aantal }
     else Writeln('No Parallelports detected ...');
End; { proc. ShowParallelPorts }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function ShowBaudRate(BaseAddr: Word):Real;
Var TempByte,
    BaudRate : Word;
Begin;
 TempByte := Port[BaseAddr + 03];

 Port[BaseAddr + 03] := TempByte OR $80;
 BaudRate := PortW[BaseAddr];
 If BaudRate=00 then ShowBaudRate := 00
  else ShowBaudRate := 115200 / BaudRate;

 Port[BaseAddr + 03] := TempByte;
End; { func. ShowBaudRate }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function ShowParity(BaseAddr: Word):String;
Begin;
 Case Port[BaseAddr + 03] AND $38 of
   $00,
   $10,
   $20,
   $30 : ShowParity := 'None';
   $08 : ShowParity := 'Odd';
   $18 : ShowParity := 'Even';
   $28 : ShowParity := 'Mark';
   $38 : ShowParity := 'Space'
 End; { Case }
End; { func. ShowParity }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function ShowDataBits(BaseAddr: Word): String;
Begin;
 ShowDataBits := FStr((Port[BaseAddr + 03] AND $03) + 05);
End; { func. ShowDataBits }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function ShowStopBits(BaseAddr: Word): String;
Begin;
 Case Port[BaseAddr + 03] AND $07 of
  $00..$03 : ShowStopBits := '1';
  $04      : ShowStopBits := '1.5';
  $05..$07 : ShowStopBits := '2';
 End; { Case }

End; { func. ShowStopBits }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Function ShowUART(BaseAddr: Word): String;
Var TempByte: Byte;
    UARTByte: Byte;
Begin;
 ShowUART := '[Unknown]';

 TempByte := Port[BaseAddr + 02];                     { Save original setting }
 Port[BaseAddr + 02] := $C1;
 Port[BaseAddr + 02] := TempByte;                      { Restore this setting }
 UARTByte := Port[BaseAddr + 02];

 Case ((UARTBYte AND $C0) SHR 6) of
   00 : Begin;
         TempByte := Port[BaseAddr + 07];
         Port[BaseAddr + 07] := $FA;
         Delay(200);
         If Port[BaseAddr + 07] = $FA then
          Begin;
           Port[BaseAddr + 07] := $AF;
           Delay(200);
           If Port[BaseAddr + 07] = $AF then
            Begin;
             Port[BaseAddr + 07] := TempByte;
             ShowUART := '16450';
            End { If Port }
             else ShowUART := '8250'
          End; { If Port }
        End; { Case }
   02 : ShowUART := '16550';
   03 : ShowUART := '16550A';
 End; { Case }

End; { func. ShowUART }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)


Procedure ShowSerialPorts;
Var Aantal     : Byte;
    Teller     : Byte;
    BaseAddr   : Word;
    StatusByte : Byte;
Begin;
 Aantal := 00;
 If MemW[BiosDSeg: $00] <> $0000 then
  Aantal := 01;
 If MemW[BiosDSeg: $02] <> $0000 then
  Aantal := 02;
 If MemW[BiosDSeg: $04] <> $0000 then
  Aantal := 03;
 If MemW[BiosDSeg: $06] <> $0000 then
  Aantal := 04;

 If Aantal>00 then
  Begin;
   Writeln('SerialPorts: ', Aantal);
   Writeln;
   Writeln('Device               :');
   Writeln('Base port            :');
   Writeln('BaudRate             :');
   Writeln('Parity               :');
   Writeln('Data Bits            :');
   Writeln('Stop bits            :');
   Writeln('Carrier Detect (CD)  :');
   Writeln('Ring Indicator (RI)  :');
   Writeln('Data Set Ready (DSR) :');
   Writeln('Clear to Send  (CTS) :');
   Writeln('UART                 :');

   For Teller:=01 to Aantal
    do Begin;
         BaseAddr := MemW[BiosDSeg: 2 * Teller - 2];
         If BaseAddr>00 then
          Begin;
           Regs.AH := $03;
           Regs.AL := $00;
           Regs.DX := Teller - 01;
           Intr($14, Regs);
           StatusByte := Regs.AL;

           GotoXY(18 + (7 * Teller), 03); Writeln('COM', Teller);
           GotoXY(18 + (7 * Teller), 04); Writeln('$', HexWord(BaseAddr));
           GotoXY(18 + (7 * Teller), 05); Writeln(ShowBaudRate(BaseAddr):0:0);
           GotoXY(18 + (7 * Teller), 06); Writeln(ShowParity(Teller));
           GotoXY(18 + (7 * Teller), 07); Writeln(ShowDataBits(BaseAddr));
           GotoXY(18 + (7 * Teller), 08); Writeln(ShowStopBits(BaseAddr));
           GotoXY(18 + (7 * Teller), 09); Writeln(Bit2Str(StatusByte, 7));
           GotoXY(18 + (7 * Teller), 10); Writeln(Bit2Str(StatusByte, 6));
           GotoXY(18 + (7 * Teller), 11); Writeln(Bit2Str(StatusByte, 5));
           GotoXY(18 + (7 * Teller), 12); Writeln(Bit2Str(StatusByte, 4));
           GotoXY(18 + (7 * Teller), 13); Writeln(ShowUART(BaseAddr));
          End
           else Begin;
                 GotoXY(18 + (7 * Teller), 03); Writeln('COM', Teller);
                 GotoXY(18 + (7 * Teller), 04); Writeln('N/A');
                End; { If Comport not available }
       End; { For Teller }
  End { If Aantal }
   else Writeln('No serialports detected...');
End; { proc. ShowSerialPorts }

(*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-+-*-*)

Procedure ShowPortsInfo;
Begin;
{ ShowParallelPorts; }
 ShowSerialPorts;
End; { proc. ShowPortsInfo }
